#pragma once
#include <unknwn.h>
#include "DataDef.h"

#define DEVICE_ADT760		(0x01)
#define DEVICE_ADT761A		(0x02)
#define DEVICE_ADT227		(0x03)

#define DEVICE_MODEL		DEVICE_ADT227

#if DEVICE_MODEL == DEVICE_ADT760
// E8389AED-7B15-11D1-B326-00001CBE02AA
_declspec(selectany) GUID CLSID_CalibratorInfo =
{ 0xe8389aed,0x7b15,0x11d1,{0xb3,0x26,0x0,0x0,0x1c,0xbe,0x02,0xaa} };//ɲͬ豸ӦCOMʱ޸GUID(עɶӦעԲظ)
//Device Type
_declspec(selectany) char* g_deviceFlag = "ADT760";

#elif DEVICE_MODEL == DEVICE_ADT761A
// E8390AED-7B15-11D1-B326-00001CBE02AA
_declspec(selectany) GUID CLSID_CalibratorInfo =
{ 0xe8390aed,0x7b15,0x11d1,{0xb3,0x26,0x0,0x0,0x1c,0xbe,0x02,0xaa} };//ɲͬ豸ӦCOMʱ޸GUID(עɶӦעԲظ)
//Device Type
_declspec(selectany) char* g_deviceFlag = "ADT761A";

#elif DEVICE_MODEL == DEVICE_ADT227
// E8391AED-7B15-11D1-B326-00001CBE02AA
_declspec(selectany) GUID CLSID_CalibratorInfo =
{ 0xe8391aed,0x7b15,0x11d1,{0xb3,0x26,0x0,0x0,0x1c,0xbe,0x02,0xaa} };//ɲͬ豸ӦCOMʱ޸GUID(עɶӦעԲظ)
//Device Type
_declspec(selectany) char* g_deviceFlag = "ADT227";

#endif


//FF5EFD41-7B15-11D1-B326-00001CBE02AA
_declspec(selectany) GUID IID_CalibratorInfo =
{ 0xff5efd41,0x7b15,0x11d1,{0xb3,0x26,0x0,0x0,0x1c,0xbe,0x02,0xaa} };

// FF5EFD42-7B15-11D1-B326-00001CBE02AA
_declspec(selectany) GUID IID_CalibratorDownload =
{ 0xff5efd42,0x7b15,0x11d1,{0xb3,0x26,0x0,0x0,0x1c,0xbe,0x02,0xaa} };

// FF5EFD43-7B15-11D1-B326-00001CBE02AA
_declspec(selectany) GUID IID_CalibratorUpload =
{ 0xff5efd43,0x7b15,0x11d1,{0xb3,0x26,0x0,0x0,0x1c,0xbe,0x02,0xaa} };

class ICalibratorInfo : public IUnknown
{
public:
	virtual HRESULT STDMETHODCALLTYPE DriverProperties(FCISTATUS* pStatus) = 0;//Ϊ麯
	virtual HRESULT STDMETHODCALLTYPE Open(int nPortNumber, long* plSessionId, long* plCapabilities, FCISTATUS* pStatus) = 0;
	virtual HRESULT STDMETHODCALLTYPE Close(long lSessionId, FCISTATUS* pStatus) = 0;
	virtual HRESULT STDMETHODCALLTYPE Properties(long lSessionId, FCISTATUS* pStatus) = 0;
	virtual HRESULT STDMETHODCALLTYPE GetId(long lSessionId, LPWSTR* pszwCalManufacturer, LPWSTR* pszwCalModel, LPWSTR* pszwCalSerialNum, FCISTATUS* pStatus) = 0;
	virtual HRESULT STDMETHODCALLTYPE GetCalDates(long lSessionId, SYSTEMTIME* pLastCalDate, SYSTEMTIME* pNextCalDueDate, FCISTATUS* pStatus) = 0;
	virtual HRESULT STDMETHODCALLTYPE SetDateAndTime(long lSessionId, FCISTATUS* pStatus) = 0;
	virtual HRESULT STDMETHODCALLTYPE SetTempStandard(long lSessionId, int nTemperatureStd, FCISTATUS* pStatus) = 0;
	virtual HRESULT STDMETHODCALLTYPE GetTestResultsCount(long lSessionId, int* pnCount, FCISTATUS* pStatus) = 0;
	virtual HRESULT STDMETHODCALLTYPE ClearMemory(long lSessionId, FCISTATUS* pStatus) = 0;
	virtual HRESULT STDMETHODCALLTYPE ValidateTag(FCICOMMDEF* pCommDef, FCIDEVIN* pInputDef, FCIDEVOUT* pOutputDef, FCIDEVRELATION* pRelationDef, FCITEST* pTestDef, FCISTATUS* pStatus) = 0;
};

class ICalibratorDownload : public IUnknown
{
public:
	virtual HRESULT STDMETHODCALLTYPE StartDownloading(long lSessionId, LPCWSTR szSessionName, FCISTATUS* pStatus) = 0;//Ϊ麯
	virtual HRESULT STDMETHODCALLTYPE DownloadTag(long lSessionId, LPCWSTR szwDeviceTag, LPCWSTR szwDeviceSerialNum, FCICOMMDEF* pCommDef, FCIDEVIN* pInputDef, FCIDEVOUT* pOutputDef, FCIDEVRELATION* pRelationDef, FCITEST* pTestDef, LPCWSTR szwSetupInstructions, LPCWSTR szwCleanupInstructions, LPWSTR* pszwLocationInCalibrator, FCISTATUS* pStatus) = 0;
	virtual HRESULT STDMETHODCALLTYPE FinishDownloading(long lSessionId, FCISTATUS* pStatus) = 0;
	virtual HRESULT STDMETHODCALLTYPE AbortDownload(long lSessionId, FCISTATUS* pStatus) = 0;
	virtual HRESULT STDMETHODCALLTYPE DeleteTag(long lSessionId, LPCWSTR szwLocationInCalibrator, FCISTATUS* pStatus) = 0;
	virtual HRESULT STDMETHODCALLTYPE AddFolder(long lSessionId, LPCWSTR szwFolderName, LPCWSTR szwParentId, LPWSTR* pszwGroupId,FCISTATUS* pStatus) = 0;
	virtual HRESULT STDMETHODCALLTYPE DeleteFolder(long lSessionId, LPCWSTR szwGroupId, FCISTATUS* pStatus) = 0;
	virtual HRESULT STDMETHODCALLTYPE GetFolder(long lSessionId, LPCWSTR szwFolderName, LPCWSTR szwParentId, LPWSTR* pszwGroupId,FCISTATUS* pStatus) = 0;
	virtual HRESULT STDMETHODCALLTYPE EnterFolder(long lSessionId, LPCWSTR szwGroupId, FCISTATUS* pStatus) = 0;
	virtual HRESULT STDMETHODCALLTYPE GetSubFolder(long lSessionId, LPCWSTR szwParentId, FCI_FOLDER pGroupIds[],int nSize,int* pnCount,FCISTATUS* pStatus) = 0;
	virtual HRESULT STDMETHODCALLTYPE GetFolderTags(long lSessionId, LPCWSTR szwParentId, FCI_TAG pTags[],int nSize,int* pnCount,FCISTATUS* pStatus) = 0;
};

class ICalibratorUpload : public IUnknown
{
public:
	virtual HRESULT STDMETHODCALLTYPE StartUploading(long lSessionId, FCISTATUS* pStatus) = 0;
	virtual HRESULT STDMETHODCALLTYPE UploadNextTag(long lSessionId, LPWSTR* pszwLocationInCalibrator, LPWSTR* pszwDeviceTag, LPWSTR* pszwDeviceSerialNum, LPWSTR* pszwTechnician, LPWSTR* pszwServiceNote, int* pnTemperatureStd, FCICOMMDEF* pCommDef, FCIRESULT* pAsFound, FCIRESULT* pAsLeft, FCISTATUS* pStatus) = 0;
	virtual HRESULT STDMETHODCALLTYPE FinishUploading(long lSessionId, FCISTATUS* pStatus) = 0;
	virtual HRESULT STDMETHODCALLTYPE AbortUpload(long lSessionId, FCISTATUS* pStatus) = 0;
	virtual HRESULT STDMETHODCALLTYPE UploadNextResult(long lSessionId, LPWSTR* pszwLocationInCalibrator, LPWSTR* pszwDeviceTag, LPWSTR* pszwDeviceSerialNum, LPWSTR* pszwTechnician, LPWSTR* pszwServiceNote, int* pnTemperatureStd, FCICOMMDEF* pCommDef, FCIRESULT* pAsFound, FCIRESULT* pAsLeft, FCISTATUS* pStatus) = 0;
};